<template>
  <div class="">
    <toolbar @on-filter="filterData" @on-reset="filterData" />

    <div class="m-10 bg-w p-20 br-10">
      <el-button type="primary" icon="el-icon-plus" @click="handleAdd"
        >新增</el-button
      >
      <base-table
        :columns="columns"
        :items="items"
        :pagination="pagination"
        :page-change="pageChange"
      />
    </div>
  </div>
</template>

<script>
import toolbar from './toolbar';
import mxFilterList from '@/mixins/filterList';
import { getPage, delItem } from '@/api/base/info';

export default {
  name: 'InfoManagement',

  components: { toolbar },

  mixins: [
    mxFilterList({
      fetchList: getPage // 在下方data再声明一个 fetchList: iGetList 同等效果
    })
  ],

  data() {
    return {
      columns: [
        {
          key: 'title',
          name: '标题',
          minWidth: this.$col.b
        },
        {
          key: 'author',
          name: '作者',
          width: this.$col.s
        },
        {
          key: 'looks',
          name: '阅读',
          width: this.$col.s,
          render: (h, { row }) => h('span', row.looks)
        },
        {
          key: 'likes',
          name: '点赞',
          width: this.$col.s,
          render: (h, { row }) => h('span', row.likes)
        },
        {
          key: 'collections',
          name: '收藏',
          width: this.$col.s,
          render: (h, { row }) => h('span', row.collections)
        },
        {
          key: 'sort',
          name: '排序',
          width: this.$col.s
        },
        {
          key: 'createAt',
          name: '发布时间',
          width: this.$col.b
        },
        {
          key: 'isShow',
          name: '状态',
          width: this.$col.s,
          type: 'tag',
          fetchTagType: val => (val ? 'success' : 'info'),
          tagName: row => (row.isShow ? '显示' : '隐藏')
        },
        {
          key: 'action',
          name: '操作',
          width: '120',
          render: (h, { row }) => {
            const action = [];
            action.push(
              h(
                'el-button',
                {
                  props: {
                    type: 'text'
                  },
                  on: {
                    click: () =>
                      this.$InfoItemModal({
                        id: row.id
                      })
                  }
                },
                '编辑'
              )
            );
            action.push(
              h(
                'BaseBtn',
                {
                  props: {
                    popip: true,
                    txt: '删除',
                    type: 'text'
                  },
                  class: 'ml-10',
                  on: {
                    ok: () => this.handleDelItem(row)
                  }
                },
                '删除'
              )
            );

            return h('div', action);
          }
        }
      ]
    };
  },

  created() {
    this.$g_on('base_info_reload', this.reload);
  },

  beforeDestroy() {
    this.$g_off('base_info_reload', this.reload);
  },

  methods: {
    handleAdd() {
      this.$InfoItemModal();
    },
    async handleDelItem(item) {
      const { success, msg } = await delItem({
        id: item.id
      });
      if (success) {
        this.$success('删除成功！');
        this.$g_emit('base_info_reload');
      }
    }
  }
};
</script>

<style type="scss" scoped></style>
